---
content_title: Key-Value Map
link_text: "Key-Value Map"
---

The `KV Map` offered by the `KV API` serves as a storage location which is organized as a sorted associative container that contains key-value pairs with unique keys. Keys are sorted lexicographically. Search, removal, and insertion operations have logarithmic complexity, `O(log(n))`. 'KV Map' is designed to offer a comparable interface to `std::map` template class.

Consult the [KV Map Reference](../../../classeosio_1_1kv_1_1map/#class-eosiokvmap) and the `KV Map How-To`s listed below for details.

* [How To Use KV Map](./10_how-to-use-kv-map.md)
* [How To Upsert Into KV Map](./30_how-to-upsert-into-kv-map.md)
* [How To Delete From KV Map](./40_how-to-delete-from-kv-map.md)
* [How To Iterate Trough KV Map Keys](./50_how-to-iterate-kv-map.md)
* [How To Find In KV Map](./70_how-to-find-in-kv-map.md)
* [How To Allow Users To Pay](./90_how-to-allow-users-to-pay-kv-map.md)
